=== src/widgets/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## Widgets Module:
#####################################################################

qt_internal_add_module(Widgets
    QMAKE_MODULE_CONFIG uic
    PLUGIN_TYPES styles
    SOURCES
        compat/removed_api.cpp
        itemviews/qfileiconprovider.cpp itemviews/qfileiconprovider.h itemviews/qfileiconprovider_p.h
        kernel/qapplication.cpp kernel/qapplication.h kernel/qapplication_p.h
        kernel/qboxlayout.cpp kernel/qboxlayout.h
        kernel/qgesture.cpp kernel/qgesture.h kernel/qgesture_p.h
        kernel/qgesturemanager.cpp kernel/qgesturemanager_p.h
        kernel/qgesturerecognizer.cpp kernel/qgesturerecognizer.h
        kernel/qgridlayout.cpp kernel/qgridlayout.h
        kernel/qlayout.cpp kernel/qlayout.h kernel/qlayout_p.h
        kernel/qlayoutengine.cpp kernel/qlayoutengine_p.h
        kernel/qlayoutitem.cpp kernel/qlayoutitem.h
        kernel/qrhiwidget.cpp kernel/qrhiwidget.h kernel/qrhiwidget_p.h
        kernel/qsizepolicy.cpp kernel/qsizepolicy.h
        kernel/qstackedlayout.cpp kernel/qstackedlayout.h
        kernel/qstandardgestures.cpp kernel/qstandardgestures_p.h
        kernel/qtestsupport_widgets.cpp kernel/qtestsupport_widgets.h
        kernel/qtwidgetsglobal.h kernel/qtwidgetsglobal_p.h
        kernel/qwidget.cpp kernel/qwidget.h kernel/qwidget_p.h
        kernel/qwidgetrepaintmanager.cpp kernel/qwidgetrepaintmanager_p.h
        kernel/qwidgetsvariant.cpp
        kernel/qwidgetwindow.cpp kernel/qwidgetwindow_p.h
        kernel/qwindowcontainer.cpp kernel/qwindowcontainer_p.h
        styles/qcommonstyle.cpp styles/qcommonstyle.h styles/qcommonstyle_p.h
        styles/qcommonstylepixmaps_p.h
        styles/qdrawutil.cpp styles/qdrawutil.h
        styles/qpixmapstyle.cpp styles/qpixmapstyle_p.h
        styles/qpixmapstyle_p_p.h
        styles/qproxystyle.cpp styles/qproxystyle.h styles/qproxystyle_p.h
        styles/qstyle.cpp styles/qstyle.h styles/qstyle_p.h
        styles/qstylefactory.cpp styles/qstylefactory.h
        styles/qstylehelper.cpp styles/qstylehelper_p.h
        styles/qstyleoption.cpp styles/qstyleoption.h
        styles/qstylepainter.cpp styles/qstylepainter.h
        styles/qstyleplugin.cpp styles/qstyleplugin.h
        util/qcolormap.cpp util/qcolormap.h
        util/qsystemtrayicon.cpp util/qsystemtrayicon.h util/qsystemtrayicon_p.h
        widgets/qabstractscrollarea.cpp widgets/qabstractscrollarea.h widgets/qabstractscrollarea_p.h
        widgets/qfocusframe.cpp widgets/qfocusframe.h
        widgets/qframe.cpp widgets/qframe.h widgets/qframe_p.h
        widgets/qwidgetanimator.cpp widgets/qwidgetanimator_p.h
    DEFINES
        QT_NO_CONTEXTLESS_CONNECT
        QT_NO_USING_NAMESPACE
        QT_NO_FOREACH
        QT_USE_NODISCARD_FILE_OPEN
    INCLUDE_DIRECTORIES
        dialogs
    LIBRARIES
        Qt::CorePrivate
        Qt::GuiPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
        Qt::GuiPrivate
    PRECOMPILED_HEADER
        "kernel/qt_widgets_pch.h"
    NO_PCH_SOURCES
        compat/removed_api.cpp
    ELF_LINKER_DYNAMIC_LIST
        QtWidgets.dynlist.in
)

qt_internal_extend_target(Widgets CONDITION APPLE
    NO_UNITY_BUILD_SOURCES
        kernel/qapplication.cpp
)

# Resources:
set(qstyle_resource_files
    "styles/images/arrow-down-128.png"
    "styles/images/arrow-down-16.png"
    "styles/images/arrow-down-32.png"
    "styles/images/arrow-left-128.png"
    "styles/images/arrow-left-16.png"
    "styles/images/arrow-left-32.png"
    "styles/images/arrow-right-128.png"
    "styles/images/arrow-right-16.png"
    "styles/images/arrow-right-32.png"
    "styles/images/arrow-up-128.png"
    "styles/images/arrow-up-16.png"
    "styles/images/arrow-up-32.png"
    "styles/images/cdr-128.png"
    "styles/images/cdr-16.png"
    "styles/images/cdr-32.png"
    "styles/images/cleartext-128.png"
    "styles/images/cleartext-16.png"
    "styles/images/cleartext-32.png"
    "styles/images/closedock-10.png"
    "styles/images/closedock-16.png"
    "styles/images/closedock-20.png"
    "styles/images/closedock-32.png"
    "styles/images/closedock-48.png"
    "styles/images/closedock-64.png"
    "styles/images/computer-16.png"
    "styles/images/computer-32.png"
    "styles/images/critical-128.png"
    "styles/images/critical-16.png"
    "styles/images/critical-32.png"
    "styles/images/desktop-16.png"
    "styles/images/desktop-32.png"
    "styles/images/dirclosed-128.png"
    "styles/images/dirclosed-16.png"
    "styles/images/dirclosed-32.png"
    "styles/images/dirlink-128.png"
    "styles/images/dirlink-16.png"
    "styles/images/dirlink-32.png"
    "styles/images/diropen-128.png"
    "styles/images/diropen-16.png"
    "styles/images/diropen-32.png"
    "styles/images/dvd-128.png"
    "styles/images/dvd-16.png"
    "styles/images/dvd-32.png"
    "styles/images/file-128.png"
    "styles/images/file-16.png"
    "styles/images/file-32.png"
    "styles/images/filecontents-128.png"
    "styles/images/filecontents-16.png"
    "styles/images/filecontents-32.png"
    "styles/images/filedialog_end-128.png"
    "styles/images/filedialog_end-16.png"
    "styles/images/filedialog_end-32.png"
    "styles/images/filedialog_start-128.png"
    "styles/images/filedialog_start-16.png"
    "styles/images/filedialog_start-32.png"
    "styles/images/fileinfo-128.png"
    "styles/images/fileinfo-16.png"
    "styles/images/fileinfo-32.png"
    "styles/images/filelink-128.png"
    "styles/images/filelink-16.png"
    "styles/images/filelink-32.png"
    "styles/images/floppy-128.png"
    "styles/images/floppy-16.png"
    "styles/images/floppy-32.png"
    "styles/images/fontbitmap-16.png"
    "styles/images/fonttruetype-16.png"
    "styles/images/fusion_groupbox.png"
    "styles/images/harddrive-128.png"
    "styles/images/harddrive-16.png"
    "styles/images/harddrive-32.png"
    "styles/images/information-128.png"
    "styles/images/information-16.png"
    "styles/images/information-32.png"
    "styles/images/media-pause-128.png"
    "styles/images/media-pause-16.png"
    "styles/images/media-pause-32.png"
    "styles/images/media-play-128.png"
    "styles/images/media-play-16.png"
    "styles/images/media-play-32.png"
    "styles/images/media-seek-backward-128.png"
    "styles/images/media-seek-backward-16.png"
    "styles/images/media-seek-backward-32.png"
    "styles/images/media-seek-forward-128.png"
    "styles/images/media-seek-forward-16.png"
    "styles/images/media-seek-forward-32.png"
    "styles/images/media-skip-backward-128.png"
    "styles/images/media-skip-backward-16.png"
    "styles/images/media-skip-backward-32.png"
    "styles/images/media-skip-forward-128.png"
    "styles/images/media-skip-forward-16.png"
    "styles/images/media-skip-forward-32.png"
    "styles/images/media-stop-128.png"
    "styles/images/media-stop-16.png"
    "styles/images/media-stop-32.png"
    "styles/images/media-volume-16.png"
    "styles/images/media-volume-32.png"
    "styles/images/media-volume-128.png"
    "styles/images/media-volume-muted-16.png"
    "styles/images/media-volume-muted-32.png"
    "styles/images/media-volume-muted-128.png"
    "styles/images/networkdrive-128.png"
    "styles/images/networkdrive-16.png"
    "styles/images/networkdrive-32.png"
    "styles/images/newdirectory-128.png"
    "styles/images/newdirectory-16.png"
    "styles/images/newdirectory-32.png"
    "styles/images/normalizedockup-10.png"
    "styles/images/normalizedockup-16.png"
    "styles/images/normalizedockup-20.png"
    "styles/images/normalizedockup-32.png"
    "styles/images/normalizedockup-48.png"
    "styles/images/normalizedockup-64.png"
    "styles/images/parentdir-128.png"
    "styles/images/parentdir-16.png"
    "styles/images/parentdir-32.png"
    "styles/images/question-128.png"
    "styles/images/question-16.png"
    "styles/images/question-32.png"
    "styles/images/refresh-24.png"
    "styles/images/refresh-32.png"
    "styles/images/standardbutton-apply-128.png"
    "styles/images/standardbutton-apply-16.png"
    "styles/images/standardbutton-apply-32.png"
    "styles/images/standardbutton-cancel-128.png"
    "styles/images/standardbutton-cancel-16.png"
    "styles/images/standardbutton-cancel-32.png"
    "styles/images/standardbutton-clear-128.png"
    "styles/images/standardbutton-clear-16.png"
    "styles/images/standardbutton-clear-32.png"
    "styles/images/standardbutton-close-128.png"
    "styles/images/standardbutton-close-16.png"
    "styles/images/standardbutton-close-32.png"
    "styles/images/standardbutton-closetab-128.png"
    "styles/images/standardbutton-closetab-16.png"
    "styles/images/standardbutton-closetab-32.png"
    "styles/images/standardbutton-closetab-down-128.png"
    "styles/images/standardbutton-closetab-down-16.png"
    "styles/images/standardbutton-closetab-down-32.png"
    "styles/images/standardbutton-closetab-hover-128.png"
    "styles/images/standardbutton-closetab-hover-16.png"
    "styles/images/standardbutton-closetab-hover-32.png"
    "styles/images/standardbutton-delete-128.png"
    "styles/images/standardbutton-delete-16.png"
    "styles/images/standardbutton-delete-32.png"
    "styles/images/standardbutton-help-128.png"
    "styles/images/standardbutton-help-16.png"
    "styles/images/standardbutton-help-32.png"
    "styles/images/standardbutton-no-128.png"
    "styles/images/standardbutton-no-16.png"
    "styles/images/standardbutton-no-32.png"
    "styles/images/standardbutton-ok-128.png"
    "styles/images/standardbutton-ok-16.png"
    "styles/images/standardbutton-ok-32.png"
    "styles/images/standardbutton-open-128.png"
    "styles/images/standardbutton-open-16.png"
    "styles/images/standardbutton-open-32.png"
    "styles/images/standardbutton-save-128.png"
    "styles/images/standardbutton-save-16.png"
    "styles/images/standardbutton-save-32.png"
    "styles/images/standardbutton-yes-128.png"
    "styles/images/standardbutton-yes-16.png"
    "styles/images/standardbutton-yes-32.png"
    "styles/images/stop-24.png"
    "styles/images/stop-32.png"
    "styles/images/titlebar-contexthelp-16.png"
    "styles/images/titlebar-contexthelp-32.png"
    "styles/images/titlebar-contexthelp-48.png"
    "styles/images/titlebar-max-16.png"
    "styles/images/titlebar-max-32.png"
    "styles/images/titlebar-max-48.png"
    "styles/images/titlebar-min-16.png"
    "styles/images/titlebar-min-32.png"
    "styles/images/titlebar-min-48.png"
    "styles/images/titlebar-shade-16.png"
    "styles/images/titlebar-shade-32.png"
    "styles/images/titlebar-shade-48.png"
    "styles/images/titlebar-unshade-16.png"
    "styles/images/titlebar-unshade-32.png"
    "styles/images/titlebar-unshade-48.png"
    "styles/images/toolbar-ext-h-128.png"
    "styles/images/toolbar-ext-h-16.png"
    "styles/images/toolbar-ext-h-32.png"
    "styles/images/toolbar-ext-h-8.png"
    "styles/images/toolbar-ext-h-rtl-128.png"
    "styles/images/toolbar-ext-h-rtl-16.png"
    "styles/images/toolbar-ext-h-rtl-32.png"
    "styles/images/toolbar-ext-h-rtl-8.png"
    "styles/images/toolbar-ext-v-10.png"
    "styles/images/toolbar-ext-v-20.png"
    "styles/images/toolbar-ext-v-80.png"
    "styles/images/toolbar-ext-v-5.png"
    "styles/images/trash-128.png"
    "styles/images/trash-16.png"
    "styles/images/trash-32.png"
    "styles/images/viewdetailed-128.png"
    "styles/images/viewdetailed-16.png"
    "styles/images/viewdetailed-32.png"
    "styles/images/viewlist-128.png"
    "styles/images/viewlist-16.png"
    "styles/images/viewlist-32.png"
    "styles/images/warning-128.png"
    "styles/images/warning-16.png"
    "styles/images/warning-32.png"
)

qt_internal_add_resource(Widgets "qstyle"
    PREFIX
        "/qt-project.org/styles/commonstyle"
    BASE
        "styles"
    FILES
        ${qstyle_resource_files}
)
