=== tests/manual/widgets/itemviews/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(qconcatenatetablesproxymodel)
add_subdirectory(qheaderview)
add_subdirectory(qtreeview)
add_subdirectory(qtreewidget)
add_subdirectory(tableview-span-navigation)
add_subdirectory(qtablewidget-sort-indicator)
